/**
 * Created:         2005.08.02
 * Last Modified:   2006.01.19
 * Description:
 *      class TRSParserBaseTest
 * Update Log:
 *	2005.01.19	FuChengrui
 *		µ(ֻʹPublishPageContext)PublishTagContext
 *
 *	2005.12.27	FuChengrui
 *		µ(ʹTagItem)PublishTagContext
 */
package com.trs;

import com.trs.components.common.publish.domain.publisher.PublishPageContext;
import com.trs.components.common.publish.domain.publisher.PublishTagContext;
import com.trs.components.common.publish.domain.publisher.PublishTaskContext;
import com.trs.components.common.publish.domain.tagparser.TagItem;
import com.trs.components.common.publish.domain.tagparser.TagParseHelper;
import com.trs.components.common.publish.persistent.element.IPublishContent;
import com.trs.components.common.publish.persistent.element.IPublishElement;
import com.trs.components.common.publish.persistent.element.IPublishFolder;
import com.trs.components.common.publish.persistent.element.PublishElementFactory;
import com.trs.infra.common.WCMException;
import com.trs.infra.util.CMyException;

/**
 * Title: TRS Эƽ̨TRS WCM <BR>
 * Description: <BR>
 * TODO <BR>
 * Copyright: Copyright (c) 2004-2005 TRSϢ޹˾ <BR>
 * Company: TRSϢ޹˾(www.trs.com.cn) <BR>
 * 
 * @author TRSϢ޹˾
 * @version 1.0
 */

public abstract class TRSParserBaseTest extends TRSWCMBaseTest {
	private static org.apache.log4j.Logger logger = org.apache.log4j.Logger
			.getLogger(TRSParserBaseTest.class);

	/**
	 * һָContent
	 * 
	 * @param _contentContext
	 *            Ϊ4飺1FolderType 2FolderId 3ContentType 4ContentId
	 * @return
	 */
	protected IPublishContent makeContent(int[] _contentContext) {
		if (_contentContext == null) {
			logger.error("[makeContent]ĲݲȷҪ볤Ϊ24");
			fail("[makeContent]ĲݲȷҪ볤Ϊ24");
		}

		int nFolderType = 0;
		int nFolderId = 0;
		int nContentType = 0;
		int nContentId = 0;

		if (_contentContext.length == 2) {
			nContentType = _contentContext[0];
			nContentId = _contentContext[1];

		} else if (_contentContext.length >= 4) {
			nFolderType = _contentContext[0];
			nFolderId = _contentContext[1];
			nContentType = _contentContext[2];
			nContentId = _contentContext[3];
		} else {
			logger.error("[makeContent]ĲݲȷҪ볤Ϊ24");
			fail("[makeContent]ĲݲȷҪ볤Ϊ24");
		}

		try {
			IPublishContent content = (IPublishContent) PublishElementFactory
					.lookupElement(nContentType, nContentId);
			if (content == null) {
				logger.error("[makeContent]ContentݲȷContentTypeConfig="
						+ nContentType + " ContentId=" + nContentId);
				fail("[makeContent]ContentݲȷContentTypeConfig="
						+ nContentType + " ContentId=" + nContentId);
			}

			IPublishFolder folder = null;
			if (nFolderId != 0) {
				try {
					folder = (IPublishFolder) PublishElementFactory
							.lookupElement(nFolderType, nFolderId);
					if (folder == null) {
						logger
								.error("[makeContent]FolderݲȷFolderTypeConfig="
										+ nFolderType
										+ " FolderId="
										+ nFolderId);
						fail("[makeContent]FolderݲȷFolderTypeConfig="
								+ nFolderType + " FolderId=" + nFolderId);
					}
				} catch (Exception ex) {
					logger.error("[makeContent]-ȡFolder쳣", ex);
					fail("[makeContent]-ȡFolder쳣\n"
							+ CMyException.getStackTraceText(ex));
				}
			} else {
				folder = content.getOriginalHome();
			}

			content.setFolder(folder);
			return content;
		} catch (Exception ex) {
			logger.error("[makeContent]-makeContent쳣", ex);
			fail("[makeContent]-makeContent쳣\n"
					+ CMyException.getStackTraceText(ex));
		}

		return null;
	}

	/**
	 * ָFolder
	 * 
	 * @param _folderContext
	 *            Ϊ2飺1Folder Type 2Folder Id
	 * @return
	 */
	protected IPublishFolder makeFolder(int[] _folderContext) {
		if (_folderContext == null || _folderContext.length < 2) {
			logger.error("[makeContent]ĲݲȷҪ볤Ϊ4");
			fail("[makeContent]ĲݲȷҪ볤Ϊ4");
		}

		int nFolderType = _folderContext[0];
		int nFolderId = _folderContext[1];

		IPublishFolder folder = null;
		try {
			folder = (IPublishFolder) PublishElementFactory.lookupElement(
					nFolderType, nFolderId);
			if (folder == null) {
				logger.error("[makeFolder]FolderݲȷFolderTypeConfig="
						+ nFolderType + " FolderId=" + nFolderId);
				fail("[makeFolder]FolderݲȷFolderTypeConfig="
						+ nFolderType + " FolderId=" + nFolderId);
			}
		} catch (Exception ex) {
			logger.error("[makeFolder]-ȡFolder쳣", ex);
			fail("[makeFolder]-ȡFolder쳣\n"
					+ CMyException.getStackTraceText(ex));
		}
		return folder;
	}

	/**
	 * @param data
	 * @throws WCMException
	 * @throws Exception
	 */
	protected void parse(String[] data, IPublishElement _pageElement,
			IPublishElement _upperHost) throws WCMException, Exception {
		// 3.췢Ĳ
		PublishTaskContext taskContent = new PublishTaskContext(null,
				_pageElement.getFolder());
		PublishPageContext pageContext = new PublishPageContext(_pageElement,
				taskContent);
		PublishTagContext tagContext = new PublishTagContext(pageContext);
		// 4.
		TagItem tagItem;
		String[] results = null;
		for (int i = 0; i < data.length; i++) {
			tagItem = TagParseHelper.strToTagItem(data[i]);
			System.out.println(data[i]);
			System.out.println("[" + i + "]" + tagItem.toString());

			long lStart = System.currentTimeMillis();
			try {
				results = TagParseHelper.parseItem(tagItem, tagContext);
				if (pageContext.getWarnings() != null)
					System.out.println("Warning:" + pageContext.getWarnings());
			} catch (Exception ex) {
				ex.printStackTrace(System.out);
				fail();
			} finally {
				pageContext.clear();
			}

			long lEnd = System.currentTimeMillis();
			System.out.println("time used: " + (lEnd - lStart) + "ms");
			if (results != null) {
				for (int j = 0; j < results.length; j++) {
					System.out.println("result[" + j + "]: " + results[j]);
				}
			}
		}
	}

	/**
	 * @param data
	 * @param arFolder
	 * @param arContent
	 * @throws WCMException
	 * @throws Exception
	 */
	protected void parse(String[] data, int[][] arFolder, int[][] arContent)
			throws WCMException, Exception {
		for (int i = 0; i < arContent.length; i++) {
			IPublishFolder folder = makeFolder(arFolder[i]);
			IPublishContent content = makeContent(arContent[i]);

			if (arContent[i].length > 4 && arContent[i][4] == 1) {// ϸҳн
				parse(data, content, content);
			} else {// ڸҳн
				parse(data, folder, content);
			}
		}
		// endfor
	}

	/**
	 * ָվĿ·ָģƬ
	 * 
	 * @param data
	 *            ҪģƬݣΪַ飬ָҪģƬ
	 * @param arFolder
	 *            ǰģƬվĿϢΪͬһģڲͬվĿ·ǲһģ
	 *            ָվĿFolderTypeFolderIdͬʱָ磺{{101, 2}, {103, 1}}
	 * @throws WCMException
	 * @throws Exception
	 */
	protected void parseFolders(String[] data, int[][] arFolder)
			throws WCMException, Exception {
		for (int i = 0; i < arFolder.length; i++) {
			IPublishFolder folder = makeFolder(arFolder[i]);
			parse(data, folder, null);
		}
	}

	/**
	 * ָĵ·ָģƬ
	 * 
	 * @param data
	 *            ҪģƬݣΪַ飬ָҪģƬ
	 * @param arFolder
	 *            ǰģƬĵϢΪͬһģڲͬĵ·ǲһģ
	 *            ָĵFolderTypeFolderId
	 *            ѡĬΪǰĵڵĿContentTypeContentId ͬʱָ磺{{101,
	 *            2, 605, 32}, {605, 2}}
	 * @throws WCMException
	 * @throws Exception
	 */
	protected void parseContents(String[] data, int[][] arContent)
			throws WCMException, Exception {
		for (int i = 0; i < arContent.length; i++) {
			IPublishContent content = makeContent(arContent[i]);
			parse(data, content, null);
		}
	}
}