package com.trs.example;

import java.util.HashMap;

import com.trs.TRSWCMBaseTest;
import com.trs.cms.auth.persistent.User;
import com.trs.components.wcm.content.persistent.Document;
import com.trs.components.wcm.content.persistent.Documents;
import com.trs.infra.common.WCMException;
import com.trs.infra.persistent.WCMFilter;
import com.trs.infra.util.CMyDateTime;
import com.trs.infra.util.CPager;
import com.trs.webframework.controler.JSPRequestProcessor;

public class DocumentExample extends TRSWCMBaseTest {
    public void query1() throws WCMException {        
        
        
        // 1 ѯ(עϺԪض֪ԼűԵһFromԲ)
        WCMFilter filter = new WCMFilter("", "DocId>=1 and DocId<=10", "",
                "DocTitle,DocId,CrUser");

        // 2 ѯ󣬻ȡӦļ
        Documents documents = Documents.openWCMObjs(null, filter);

        // 3 ϣÿ¼
        for (int i = 0, nSize = documents.size(); i < nSize; i++) {
            Document document = (Document) documents.getAt(i);
            if (document == null)
                continue;
            // ԪصҲͨgetXXXȡ
            System.out.println("Doctitle" + document.getTitle());
            // ԪصҲͨͨgetProperty(XXX)ȡ
            // XXXΪִֶСд
            System.out.println("Doctitle" + document.getProperty("DocTitle"));
            
            // ִֶСд
            int nDefault = -1;// ֶûֵʱĬֵ
            document.getPropertyAsInt("MyField1", nDefault);
        }// END For

    }

    public void query2() throws WCMException {
        // 1 ѯ䲢WhereõĲ
        WCMFilter filter = new WCMFilter("",
                "CrUser=? and DocId<=? and CrTime<=?", "",
                "DocTitle,DocId,CrUser");
        filter.addSearchValues("admin");
        filter.addSearchValues(10);
        filter.addSearchValues(CMyDateTime.now());

        // 2 ͨӦļ϶󷢳ѯ󣬻ȡӦļ
        Documents documents = Documents.openWCMObjs(null, filter);

        // 3 ϣÿ¼
        for (int i = 0, nSize = documents.size(); i < nSize; i++) {
            Document document = (Document) documents.getAt(i);
            if (document == null)
                continue;
            // ԪصҲͨgetXXXȡ
            System.out.println("Doctitle" + document.getTitle());
        }// END For
    }

    public void query3() throws WCMException {
        // 1 ѯ䲢WhereõĲ
        WCMFilter filter = new WCMFilter("", "CrUser=? and DocId<=?", "",
                "DocTitle,DocId,CrUser");
        filter.addSearchValues("admin");
        filter.addSearchValues(10);

        // 2 ͨӦļ϶󷢳ѯ󣬻ȡӦļ
        Documents documents = Documents.openWCMObjs(null, filter);

        // 3 ҳ
        int nPageSize = 3; // ҳС
        int nCurrPageIndex = 2; // ǰʾڼҳ1ʼ
        CPager pager = new CPager(nPageSize);
        pager.setItemCount(documents.size());
        pager.setCurrentPageIndex(nCurrPageIndex);

        // 4 ϣÿ¼
        for (int i = pager.getFirstItemIndex(); i < pager.getLastItemIndex(); i++) {
            Document document = (Document) documents.getAt(i - 1);
            if (document == null)
                continue;
            // ԪصҲͨgetXXXȡ
            System.out.println("Doctitle" + document.getTitle());
        }// END For
    }

    public void deleteObjects() throws WCMException {
        // 0 ȡǰû˴ٶΪadmin
        User loginUser = User.findByName("admin");

        // 1 ȡҪɾĵ
        String sDeleteDocumentIds = "23,45,67";
        Documents documents = Documents
                .findByIds(loginUser, sDeleteDocumentIds);

        // 2 ɾ
        // Ϊ˷ֹȽע͵
        // documents.removeAll(true);
    }

    public void deleteObject() throws WCMException {
        // 0 ȡǰû˴ٶΪadmin
        User loginUser = User.findByName("admin");

        // 1 ȡҪɾĵ
        int nDeleteDocId = 23;
        Document document = Document.findById(nDeleteDocId);

        // 2 ɾ
        // Ϊ˷ֹȽע͵
        // document.delete(loginUser);
    }

    public void insertDocument() throws WCMException {
        // 0 ȡǰû˴ٶΪadmin
        User loginUser = User.findByName("admin");

        // 1 Ԫضʵ
        Document document = Document.createNewInstance();

        // 2 ñҪ
        document.setTitle("ոĵ");
        document.setPropertyWithString("DocTitle", "ոĵ");// Ҳ
        document.setChannel(43);
        document.setContent("");
        document.setHtmlContent("<b>Ӵֵ</b>ͼĻŵ");

        // 3 ִб뵽ݿ
        document.save(loginUser);
    }

    public void updateDocument() throws WCMException {
        // 0 ȡǰû˴ٶΪadmin
        User loginUser = User.findByName("admin");

        // 1 Ԫضʵ
        int nDocId = 23;
        Document document = Document.findById(nDocId);

        // 2 жǷ޸ģ޸ͬʱ׳쳣
        document.validCanEditAndLock(loginUser);

        // 3 ޸ı
        document.setTitle("ƪĵ޸һ±⣬Ǻǣһ" + System.currentTimeMillis());

        // 4 ִб޸ı
        document.save(loginUser);
    }

    public boolean containsById() throws WCMException {
        Documents documents = new Documents(null);

        // жָĵǷIDΪ23ĵ
        int nDocId = 23;
        boolean bExists = (documents.indexOf(nDocId) >= 0);

        return bExists;
    }

    public Document getById() throws WCMException {
        Documents documents = new Documents(null);

        // ȡָĵָĵIdΪ23ĵ
        int nDocId = 23;
        Document document = (Document) documents.getById(nDocId);

        return document;
    }

    public Document getByIndex() throws WCMException {
        Documents documents = new Documents(null);

        // ȡָĵе¼ĵ
        int nIndex = 2;
        Document document = (Document) documents.getAt(nIndex);

        return document;
    }

    public void remove() throws WCMException {
        Documents documents = new Documents(null);

        // Ƴָĵе¼ĵ
        int nIndex = 2;
        documents.removeAt(nIndex, false);

        // ƳָĵIDΪ23ĵ
        int nDocId = 23;
        documents.remove(nDocId, false);
    }

    public void remove2() throws WCMException {
        Documents documents = new Documents(null);

        // 룺±겻Ӧõ
        for (int i = 0, nSize = documents.size(); i < nSize; i++) {
            Document document = (Document) documents.getAt(i);
            if (hasRight(document))
                continue;

            documents.removeAt(i, false);
        }// END For

        // ȷ룺±Ӧõݼ
        for (int i = documents.size() - 1; i >= 0; i--) {
            Document document = (Document) documents.getAt(i);
            if (hasRight(document))
                continue;

            documents.removeAt(i, false);
        }// END For

    }

    private boolean hasRight(Document document) {
        return false;

    }

    public void queryFromOtherTable() throws WCMException {
        // 1 WCMChnlDocжȡ
        WCMFilter filter = new WCMFilter("WCMChnlDoc",
                "DocChannel=? and Modal=1 Group by DocId", "DocId desc", "DocId");
        filter.addSearchValues(43);
        

        // 2 DocumentsϣMaxSizePageSizeСһ
        int nExpectMaxCount = 100;
        filter.setMaxRowNumber(nExpectMaxCount);
        filter.setPageSize(nExpectMaxCount);
        Documents documents = Documents.openWCMObjs(null, filter);

        // 3 ѯ󣬴DBȡ
        documents.open(filter);
        
        for (int i = 0, nSize = documents.size(); i < nSize; i++) {
            Document document = (Document) documents.getAt(i);

            System.out.println("StatusId" + document.getStatusId());
        }// END For
    }
}
