package com.trs.exchange.metadata;

import java.util.ArrayList;
import java.util.List;

import com.trs.DreamFactory;
import com.trs.TRSWCMBaseTest;
import com.trs.cms.CMSConstants;
import com.trs.cms.content.CMSObj;
import com.trs.components.metadata.center.MetaViewData;
import com.trs.components.metadata.definition.MetaView;
import com.trs.components.wcm.content.domain.AppendixMgr;
import com.trs.components.wcm.content.persistent.Appendix;
import com.trs.components.wcm.content.persistent.Channel;
import com.trs.gov.common.log.MetaDataLog;
import com.trs.gov.editorcenter.document.IGovDocumentMgr;
import com.trs.gov.editorcenter.extVersion.ExtObjectVersionMgr;
import com.trs.gov.metadata.GovMetaDataConstants;
import com.trs.infra.common.WCMException;
import com.trs.infra.persistent.db.DBManager;
import com.trs.infra.util.CMyDateTime;
import com.trs.infra.util.CMyException;

public class MetaDataExchangeTest extends TRSWCMBaseTest {
	private static org.apache.log4j.Logger logger = org.apache.log4j.Logger
			.getLogger(MetaDataExchangeTest.class);

	/**
	 * ĬϵĿID
	 */
	private int m_nChannelIdForTest = 12;

	private AppendixMgr m_oAppendixMgr = (AppendixMgr) DreamFactory
			.createObjectById("AppendixMgr");

	private IGovDocumentMgr m_oGovDocumentMgr = (IGovDocumentMgr) DreamFactory
			.createObjectById("IGovDocumentMgr");

	private ExtObjectVersionMgr m_oVersionMgr = (ExtObjectVersionMgr) DreamFactory
			.createObjectById("ExtObjectVersionMgr");

	/**
	 * һƪ򵥵վ
	 */
	public void testSaveNews() {
		try {
			MetaViewData oMetaData = saveGovNews();
			assertNotNull("վѶʧܣ", oMetaData);
		} catch (Exception ex) {
			logger.error("[testSaveMetaViewData]쳣", ex);
			fail("[testSaveMetaViewData]쳣\n"
					+ CMyException.getStackTraceText(ex));
		}

	}

	/**
	 * һƪиվ
	 */
	public void testSaveNewsContainsAppendix() {
		try {
			// 1 
			MetaViewData oMetaData = saveGovNews();
			assertNotNull("վѶʧܣ", oMetaData);

			// 2 渽
			dowithAppendix(oMetaData, Appendix.FLAG_DOCPIC);
			dowithAppendix(oMetaData, Appendix.FLAG_DOCAPD);

			// 3 ͼϢThumbfiles
			m_oGovDocumentMgr.updateThumbAndAttachField(oMetaData);

			// 4 汾̫࣬齫ע͵
			MetaDataLog oMetaDataLog = creatLog(oMetaData);
			// 汾
			m_oVersionMgr.buildVersion(oMetaData, oMetaDataLog);
			// ½Ҫ汾޸Ϊ̰汾
			m_oVersionMgr.updateProcess(m_oLoginUser.getName(),
					oMetaData.getId());

		} catch (Exception ex) {
			logger.error("[testSaveNewsContainsAppendix]쳣", ex);
			fail("[testSaveNewsContainsAppendix]쳣\n"
					+ CMyException.getStackTraceText(ex));
		}

	}
	
	private MetaViewData saveGovNews() throws Exception, WCMException {
		DBManager dbMgrForWCM = DBManager.getDBManager();

		// 0 ĿͼĿĿ
		MetaView view = GovMetaDataConstants.findGovNewsView();

		Channel channel = Channel.findById(m_nChannelIdForTest);
		assertNotNull("ָĿ" + m_nChannelIdForTest + "ڣ", channel);

		// 1 µԪ
		MetaViewData oMetaData = new MetaViewData(view);

		// 2 ȡԣӲʾ
		int nFromType = 711, nSrcId = 1008; // ԭʼݵͣԼ711ʾڲ֣ID
		oMetaData.setProperty("FromType", nFromType);
		oMetaData.setProperty("FromId", String.valueOf(nSrcId));

		oMetaData.setProperty("DocType", CMSConstants.CONTENT_BODY_HTML);
		oMetaData.setProperty("ChannelId", m_nChannelIdForTest);

		oMetaData.setPropertyWithString("DocTitle", "һǨƿǷ"); // 

		String sHTMLContent = "<DIV class=\"TRS_UEDITOR TRS_WEB\">"//
				+ "<BR>󷢴򷢵򷢵ʦ<B>dafdsf</B><P></P>" + "</DIV>";// ϵͳҪͼĻݶҪһDIV
		oMetaData.setPropertyWithString("DocHTMLCon", sHTMLContent); // 
		oMetaData.setProperty("DocContent", "󷢴򷢵򷢵ʦdafdsf\n\n");// ʽ

		oMetaData.setProperty("ShortTitle", "ҳ");
		oMetaData.setProperty("SUBDOCTITLE", "Ǹ");
		oMetaData.setProperty("DOCSOURCENAME", "Դ");
		oMetaData.setProperty("DocAbstract", "ժҪ\nڶ");

		// 3 Ᵽ
		oMetaData.save(m_oLoginUser);
		if (oMetaData.getDocument() == null) {
			throw new WCMException(
					"Fail to save metaviewdata![SrcId=" + nSrcId + "]");
		}
		// 4 DocOutupId
		dbMgrForWCM.sqlExecuteUpdate(
				new String[] {
						"update WCMDocument set DocOutupId=? where DocId=?" },
				new int[] { nSrcId, oMetaData.getDocumentId() });
		return oMetaData;
	}

	private void dowithAppendix(MetaViewData _oMetaViewData, int _nAppendixFlag)
			throws WCMException {
		// 1 ԭʼȡӦĵĸȻ󴫵WCMData/UploadĿ¼
		String[] pAppendixFile = { "U020170817494109015293.jpeg",
				"U020170817494938975762.jpg" };

		// 2 Ҫĸ
		int nSize = pAppendixFile.length;
		List<CMSObj> nAppendixs = new ArrayList<>(nSize);
		for (int i = 0; i < nSize; i++) {
			Appendix appendix = Appendix.createNewInstance();

			appendix.setFile(pAppendixFile[i]);
			appendix.setDesc("˵" + i);

			appendix.setDocId(_oMetaViewData.getMetaDataId());
			appendix.setFlag(_nAppendixFlag);
			appendix.setProperty("APPSERN", i + 1);
			nAppendixs.add(appendix);
		}

		// 3 ָ͵ĸ
		m_oAppendixMgr.saveAppendixes(_oMetaViewData.getDocument(), nAppendixs,
				_nAppendixFlag);
	}
	
	private MetaDataLog creatLog(MetaViewData _oMetaData) throws WCMException {
		MetaDataLog oMetaDataLog = MetaDataLog.createNewInstance();
		oMetaDataLog.setDesChnlId(m_nChannelIdForTest);
		oMetaDataLog.setDesDept("");
		oMetaDataLog.setDesGroupId(0);
		oMetaDataLog.setDesUser(m_sCurrUserName);
		
		oMetaDataLog.setOperTime(CMyDateTime.now());
		oMetaDataLog.setOperDesc(
				"Ǩݡ" + _oMetaData + "" + _oMetaData.getDocument() + "");
		return oMetaDataLog;
	}


}
