package com.trs.exchange.document;

import java.io.File;
import java.util.List;

import com.trs.components.wcm.content.persistent.Document;
import com.trs.exchange.MyDBManager;
import com.trs.infra.common.WCMException;
import com.trs.infra.persistent.WCMFilter;
import com.trs.infra.support.file.FilesMan;
import com.trs.infra.util.CMyFile;
import com.trs.infra.util.CMyString;

public class DocumentExchangeFromWCM extends DocumentExchange {
    private String m_sWCMDataPath = "g:/wcmdata/";

    private WCMFilter[] m_pFilterForQueryAppendixes = {
            // ͼƬ
            new WCMFilter(
                    "WCMAppendix",
                    "AppDocId=? and AppFlag=20",
                    "APPSERN",
                    "SrcFile,AppFile,FileExt, AppFileType, AppFlag,  AppDesc, AppLinkAlt, AppProp,AppTime,AppAuthor,CRUSER,CrTime"),
            // ļ
            new WCMFilter(
                    "WCMAppendix",
                    "AppDocId=? and AppFlag=10",
                    "APPSERN",
                    "SrcFile,AppFile,FileExt, AppFileType, AppFlag,  AppDesc, AppLinkAlt, AppProp,AppTime,AppAuthor,CRUSER,CrTime"),
            // Ӹ
            new WCMFilter(
                    "WCMAppendix",
                    "AppDocId=? and AppFlag=40",
                    "APPSERN",
                    "SrcFile,AppFile,FileExt, AppFileType, AppFlag,  AppDesc, AppLinkAlt, AppProp,AppTime,AppAuthor,CRUSER,CrTime") };

    private FilesMan m_oDstWCMFilesMan = null;

    public DocumentExchangeFromWCM(MyDBManager _dbMgr) {
        super(_dbMgr);
    }

    public void setWCMDataRootPath(String _sWCMDataRootPath) {
        m_sWCMDataPath = _sWCMDataRootPath;
        m_sWCMDataPath = CMyString.setStrEndWith(_sWCMDataRootPath,
                File.separatorChar);
        m_oDstWCMFilesMan = FilesMan.getFilesMan();
    }

    /**
     * ͼĻеͼƬͼԴ·
     * 
     * @param _document
     *            ݴӱǨƵݿжȡĸֶϢDocument
     * @param _sResName
     *            ͼĻHTMLеֵIMGǩеSrcԣ
     * @param _bAppendix
     *            ǷĵļtrueʾǸ falseʾĵ
     * @return ַطʽ
     *         1ǨƳͨ·ʵļһȫ·磺/home/web/data/img/10234.
     *         jpg
     *         2ǨƳܷ·ֻͨطʽͼƬԷһǨƳɷʵ··磺http://www
     *         .trs.com.cn/news/10234.jpg
     * 
     * @throws Exception
     */
    protected String makeResFullPathName(Document _document, String _sResName,
            boolean _bAppendix) throws Exception {
        try {
            String sFileName = CMyFile.extractFileName(_sResName);
            
            // ΪWCMļĿWCMļ·һ
            // ΨһWCMDataͬ
            String sAbsolutePath = m_oDstWCMFilesMan.mapFilePath(sFileName,
                    FilesMan.PATH_LOCAL);
            int nPos = sAbsolutePath.toUpperCase().indexOf("WCMDATA");
            if (nPos <= 0)
                throw new WCMException("ĿWCMDataԤڹһ£[" + sAbsolutePath
                        + "]");
            return m_sWCMDataPath + sAbsolutePath.substring(nPos + 8)
                    + sFileName;
        } catch (Exception e) {
            warn("Fail to dowith the file["+_sResName+"]!Document:["+_document+"]", e);
            return _sResName;
        }
    }

    /**
     * ѯSQLID?棬ԱЧʣ
     * SQL췽͹ĵѯSQLƣʹñSelectֶκWCMAppendixֶһ
     * 
     * @return WCMֶָ֧WCMļ ͼƬSQLselect 20 AppFlag, MyFileDesc AppDesc,
     *         MyFileDesc AppFileAlt, MyFileName AppFile from MyFiles where
     *         ContentId=?; ļSQLselect 10 AppFlag, MyFileDesc AppDesc,
     *         MyFileDesc AppFileAlt, MyFileName AppFile from MyFiles where
     *         ContentId=?; ӸSQLselect 40 AppFlag, MyFileDesc AppDesc,
     *         MyFileDesc AppFileAlt, MyFileName AppFile from MyFiles where
     *         ContentId=?;
     */
    protected WCMFilter[] makeFilterQueryAppendixOfDocument(Document _document) {
        // WCMǸ汾ϢǴAppendixУʵӿھͿ
        // ǵÿƪĵĸSQLƣһڲÿνһ²

        // 趨ǰĵID
        for (int i = 0; i < m_pFilterForQueryAppendixes.length; i++) {
            WCMFilter filter = m_pFilterForQueryAppendixes[i];
            filter.addSearchValues(0, _document.getOutUpId());
        }

        return m_pFilterForQueryAppendixes;
    }

    /**
     * ݴԴݿȡĵĳݽ
     * 
     * @param _document
     *            Դݿ¼нĵ
     * @return List<Appendix> ظϣ˳
     */
    protected List makeAppendixesOfDocument(Document _document)
            throws Exception {
        // nullʾĳֶеֵiǨƣһʽҲnullʾǨƸ
        return null;
    }

}
